--LED block-cipher, ShiftRows function


LIBRARY ieee;
USE ieee.std_logic_1164.all;

ENTITY shiftrows IS
  PORT (
    state_in  : IN STD_LOGIC_VECTOR(63 DOWNTO 0);
    state_out : OUT STD_LOGIC_VECTOR(63 DOWNTO 0)
    );
END shiftrows;

ARCHITECTURE rtl OF shiftrows IS
  
BEGIN

  --encryption
  
  state_out(15 DOWNTO 0)  <= state_in(15 DOWNTO 0);
  state_out(31 DOWNTO 16) <= state_in(19 DOWNTO 16) & state_in(31 DOWNTO 20);
  state_out(47 DOWNTO 32) <= state_in(39 DOWNTO 32) & state_in(47 DOWNTO 40);
  state_out(63 DOWNTO 48) <= state_in(59 DOWNTO 48) & state_in(63 DOWNTO 60);

END rtl;
