----------------------------------------------------------------------------------
-- Company: Univ Lyon, UJM-Saint-Etienne, CNRS, Laboratoire Hubert Curien UMR 5516, F-42023, SAINT-ETIENNE, France
-- Creator: Cédric Marchand 
-- 
-- Create Date:    10:56:29 11/12/2015 
-- Design Name: 
-- Module Name:    shiftrow_d - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity shiftrow_d is
  PORT (
    state_in  : IN STD_LOGIC_VECTOR(63 DOWNTO 0);
    state_out : OUT STD_LOGIC_VECTOR(63 DOWNTO 0)
  );
end shiftrow_d;

architecture Behavioral of shiftrow_d is

begin

  state_out(15 DOWNTO 0)  <= state_in(15 DOWNTO 0);
  state_out(31 DOWNTO 16) <= state_in(27 DOWNTO 16) & state_in(31 DOWNTO 28);
  state_out(47 DOWNTO 32) <= state_in(39 DOWNTO 32) & state_in(47 DOWNTO 40);
  state_out(63 DOWNTO 48) <= state_in(51 DOWNTO 48) & state_in(63 DOWNTO 52);

end Behavioral;

